function GrupoFiscal(){
	var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	var z = new ZeedhiAPIConstructor(browser, protractor);

	var self = this;
	

	this.abrir = function(){
		z.component.menu.open();
		z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais', 'Grupo Fiscal']);
	};

	this.filtrar = function(){
		z.component.footer.clickRightActionByLabel('Filtro');

	};

	this.Editar =function(){
		z.component.footer.clickCenterActionByIcon('Editar');

	},

	this.Salvar = function(){
		z.component.footer.clickRightActionByLabel('Salvar');

	};

	this.Voltar = function(){
		z.component.footer.clickLeftActionByLabel('Voltar');
	},

	this.Ok = function(){
		z.component.alert.clickMessageOk();
	},

	this.Filtro = function(){
		z.component.footer.clickRightActionByLabel('Filtro');
	},
	
	this.Open = function(){
		z.component.floatingControl.selectAction('search');
	},

	this.filtroSelecionado = function(valor){
		z.field.fieldFunctions.click('DSGRUPOFISC');
		browser.sleep('1000');
		z.util.pressKey(valor);
		z.widget.grid.clickColumn('0', '0', '0', false);
		self.Filtro();
	},

	this.Adicionar = function(codigo, descricao){
		z.component.footer.clickCenterActionByLabel('Adicionar');
		z.field.fieldFunctions.fill('CDGRUPOFISC', codigo);
		z.field.fieldFunctions.fill('DSGRUPOFISC', descricao);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.Alterar = function(descricao){
		z.widget.grid.clickColumn('3861781002721585151857', '0', '0');
		z.component.footer.clickCenterActionByIcon('pencil');
		z.field.fieldFunctions.fill('DSGRUPOFISC', descricao);
		self.Salvar();
		self.Voltar();
	};

	this.Excluir = function(){
		z.widget.grid.clickColumn('3861781002721585151857', '0', '0');		
		z.component.footer.clickCenterActionByIcon('trash');
		z.component.alert.clickButton('Sim');
		z.component.alert.clickMessageOk();
	},

	
	this.getGridText = function(gridid, row = 0, column = 0, checkBox = false){
		return z.widget.grid.getText(gridid, row, column, true);
	};
	
	this.gridHasText = function(gridid, column = 0, searchText, hasCheckBox = false){
		return element.all(by.repeater('rowIndex in filtered')).reduce(function(result, elem, index){
			if(result) return result;

			return self.getGridText(gridid, index, column, hasCheckBox).then(function(text){
				if(text == searchText) {
					return true;
				}
			});
		}).then(function(result){
			if(!result) return false;

			else
				return result;
		});
	}

}
module.exports = new GrupoFiscal();